package Hpl2Json;

import com.google.gson.GsonBuilder;

import java.io.*;
import java.nio.charset.Charset;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class App
{

    private static Pattern hplPattern = Pattern.compile("^hpl\\(.*?,.*?,'(.*?)'\\)\\.");
    private static List<HPL> hpls = new ArrayList();

    public static void main( String[] args )
    {
        readHplFile(Paths.get("data", "reghpl.pl").toString());
        writeJson(Paths.get("output", "hpl.json").toString());
    }


    private static void readHplFile(String hplFile) {

        try(BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(hplFile), Charset.forName("utf-8")))) {

            String line;

            while((line = reader.readLine()) != null) {

                Matcher matcher = hplPattern.matcher(line);

                if(matcher.find()) {

                    String name = matcher.group(1);

                    if(name.trim().contains("Meldepunkt")) continue;

                    hpls.add(new HPL(matcher.group(1)));

                    System.out.println(matcher.group(1));
                }
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    private static void writeJson(String filename) {

        try(FileWriter writer = new FileWriter(filename)) {


            String json = new GsonBuilder().create().toJson(hpls);

            writer.write(json);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
