package no.oslotuc.apps.index;

import fi.iki.elonen.NanoHTTPD;
import fi.iki.elonen.NanoHTTPD.Response;
import no.oslotuc.util.ErrorPages;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.FileNotFoundException;

public class IndexController {

    private static Logger logger = LogManager.getLogger(IndexController.class.getName());

    public static Response getIndex(NanoHTTPD.IHTTPSession session) {
        try {
            return new Response(Response.Status.OK, NanoHTTPD.MIME_HTML, IndexViews.getIndexView());

        } catch (FileNotFoundException e) {
            logger.error(e);
            return new Response(Response.Status.NOT_FOUND, NanoHTTPD.MIME_HTML, ErrorPages.get404NotFoundPage());
        }
    }
}
