package no.oslotuc.apps.static_files;

import fi.iki.elonen.NanoHTTPD;
import fi.iki.elonen.NanoHTTPD.Response;
import no.oslotuc.util.ErrorPages;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class StaticController {


    private static Logger logger = LogManager.getLogger(StaticController.class.getName());

    public static Response getStatic(NanoHTTPD.IHTTPSession session, String filePath) {
        Path staticPath = Paths.get("static/" + filePath);

        try {
            String mimeType = Files.probeContentType(staticPath);
            return new Response(Response.Status.OK, mimeType, new FileInputStream(staticPath.toString()));

        } catch (IOException e) {
            logger.error(e);
        }

        return new Response(Response.Status.NOT_FOUND, NanoHTTPD.MIME_HTML, ErrorPages.get404NotFoundPage());
    }
}
