package no.oslotuc.models;

import java.util.List;

public class TUCAnswer {

    public boolean transfer;
    public boolean timeset;
    public List<DepartureElement> departures;
    public List<RouteElement> route;
    public String busstuc;


    public class DepartureElement {
        public String busstopname;
        public int busstopnumber;
        public int busnumber;
        public int time;
        public int duration;
        public String destination;
    }

    public class RouteElement {
        public String name;
        public String type;
        public String role;
        public int nr;
        public String xcoord;
        public String ycoord;
    }


    public TUCAnswer formatToWeb() {

        // Remove first and last element, they are always null

        if(this.route == null)
            return this;

        this.route.remove(0);
        this.route.remove(this.route.size()-1);

        this.busstuc = this.busstuc.replaceFirst("\\n", "").replaceAll("\\n", "<br/>");
        this.busstuc = this.busstuc.replaceAll("(\\d+)", "<strong>$1</strong>");

        return this;
    }
}

