package no.oslotuc.util;

import no.oslotuc.settings.Settings;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;

public class ErrorPages {

    private static Logger logger = LogManager.getLogger(ErrorPages.class.getName());
    private static StringBuilder notFoundPage = null;

    public static String get404NotFoundPage() {

        if(notFoundPage == null) {
            try {
                notFoundPage = new StringBuilder();
                for(String line : Files.readAllLines(Paths.get(Settings.notFoundPath), Charset.forName("UTF-8"))) {
                    notFoundPage.append(line + "\n");
                }
            } catch (IOException e) {
                logger.error(e);
            }
        }

        return notFoundPage.toString();
    }
}
