package no.oslotuc.util;

import com.google.gson.GsonBuilder;
import no.oslotuc.models.QuestionLog;
import no.oslotuc.settings.Settings;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class QuestionWriter {

    private QuestionLog questionLog;
    private Logger logger = LogManager.getLogger(QuestionWriter.class.getName());

    public QuestionWriter(QuestionLog questionLog) {
        this.questionLog = questionLog;
        this.questionLog.totalTime = questionLog.endTime - questionLog.startTime;

        DateFormat dateFormat = new SimpleDateFormat("yy-MM-dd-kk-mm-ss-SSS");
        String startTimeDate = dateFormat.format(new Date(questionLog.startTime));
        this.questionLog.startTimeDate = startTimeDate;
    }


    public void saveAnswer() {

        Path path = Paths.get(Settings.logDirectoryPath, String.valueOf(questionLog.startTimeDate));

        try(FileWriter writer = new FileWriter(path.toFile().getAbsolutePath())) {
            writer.write(new GsonBuilder().create().toJson(questionLog));
        } catch (IOException e) {
            logger.error(e);
        }
    }
}
