package PrologConverter;

import RegToppParser.settings.Settings;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;
import java.nio.file.Path;
import java.nio.file.Paths;

/**
 * Created on 17.11.14.
 *
 * @author Espen
 */
public class RegWriter {

    private BufferedWriter writer;
    private Path filename;


    public RegWriter(String filename) {
        this.filename  = Paths.get(Settings.REGTOPP_OUTPUT_PATH.toString(), filename);

        try {
            writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename), Charset.forName("utf-8")));

        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("Could not find output path.");
        }
    }


    protected void writeLine(String line) {
        try {
            writer.write(line);
            writer.newLine();
        }
        catch(IOException ioException) {
            ioException.printStackTrace();
        }
    }


    protected void saveAndCloseFile() {
        try {
            writer.flush();
            writer.close();
        }
        catch(IOException ioException) {
            ioException.printStackTrace();
        }
    }
}
