package PrologConverter.regpas;

import java.util.ArrayList;
import java.util.List;

/**
 * Created on 19.11.14.
 * @author Espen
 */
public class Tour {

    private List<TourItem> tourItems = new ArrayList<>();

    private String postIndexInTDA;
    private String numberOfStops;


    public Tour(String postIndexInTDA) {
        this.postIndexInTDA = postIndexInTDA;
    }


    public Tour(String postIndexInTDA, String numberOfStops) {
        this.postIndexInTDA = postIndexInTDA;
        this.numberOfStops = numberOfStops;
    }


    public void setNumberOfStops(String numberOfStops) {
        this.numberOfStops = numberOfStops;
    }

    public List<TourItem> getTourItems() {
        return tourItems;
    }


    public String getPostIndexInTDA() {
        return postIndexInTDA;
    }


    public String getNumberOfStops() {
        return numberOfStops;
    }


    protected void addTourItem(String stopNumber, String stopName, int sequenceNumber, int drivingTimeArrival, int drivingTimeDeparture) {
        tourItems.add(new TourItem(stopNumber, stopName, sequenceNumber, drivingTimeArrival, drivingTimeDeparture));
    }


    @Override
    public boolean equals(Object object) {

        if(!(object instanceof Tour))
            return false;

        Tour tour = (Tour) object;
        List<TourItem> otherTourItems = tour.getTourItems();

        if(otherTourItems.size() != tourItems.size())
            return false;

        for(int index = 0; index < tourItems.size(); index++) {
            if(!tourItems.get(index).equals(otherTourItems.get(index))) {
                return false;
            }
        }

        return true;
    }


    @Override
    public int hashCode() {

        int hashCode = 0;

        for(TourItem tourItem : tourItems)
            hashCode += tourItem.hashCode();

        return hashCode;
    }
}
