package RegToppParser.control;

import RegToppParser.settings.Settings;
import RegToppParser.util.FileUtil;

import java.io.File;
import java.io.FileFilter;
import java.nio.file.FileStore;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class FileFinder {
	

	public static File[] findFiles(Path path) {
		return path.toFile().listFiles(new RegTopFileFilter());
	}


	private static class RegTopFileFilter implements FileFilter {
		
		public boolean accept(File file) {
			String extension = FileUtil.getFileExtension(file);
			
			if(extension == null)
				return false;
			
			return Settings.REGTOPP_ALLOWED_FILES.contains(extension.toLowerCase());
		}
	}
}


