package RegToppParser.control;

import RegToppParser.interfaces.RegToppFileParser;
import RegToppParser.models.FileType;

import java.util.HashMap;
import java.util.Map;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class FileTaskDelegator {
	
	private Map<FileType, RegToppFileParser> parsers = new HashMap<>();
	private static FileTaskDelegator fileTaskDelegator = null;

	
	private FileTaskDelegator() {}
	
	
	public static FileTaskDelegator getInstance() {
		
		if(fileTaskDelegator == null)
			fileTaskDelegator = new FileTaskDelegator();
		
		return fileTaskDelegator;
	}
	
	
	public boolean registerFileParser(RegToppFileParser fileParser, FileType fileType) {
		
		if(!parsers.containsKey(fileType)) {
			parsers.put(fileType, fileParser);
			return true;
		}
		return false;
	}

    public RegToppFileParser getFileParser(FileType fileType) {
        if(parsers.containsKey(fileType))
            return parsers.get(fileType);

        return null;
    }
}
