package RegToppParser.control;

import RegToppParser.models.FileType;
import RegToppParser.models.Version;
import RegToppParser.models.regtopp.*;

/**
 * Created on 16.11.14.
 * @author Espen Jacobsson
 */
public class VersionManager {

    public static void registerFileReaders(Version version) {

        switch (version) {
            case V_1_1_D: {
                registerVersion_1_1_D();
                break;
            }
            case V_1_2: {
                registerVersion_1_2();
                break;
            }
            case V_1_3_A: {
                registerVersion_1_3_A();
                break;
            }
        }
    }


    private static void registerVersion_1_1_D() {
        FileTaskDelegator fileTaskDelegator = FileTaskDelegator.getInstance();
        fileTaskDelegator.registerFileParser(new TIX(Version.V_1_1_D), FileType.TIX);
        fileTaskDelegator.registerFileParser(new TDA(Version.V_1_1_D), FileType.TDA);
        fileTaskDelegator.registerFileParser(new HPL(Version.V_1_1_D), FileType.HPL);
        fileTaskDelegator.registerFileParser(new DKO(Version.V_1_1_D), FileType.DKO);
        fileTaskDelegator.registerFileParser(new DST(Version.V_1_1_D), FileType.DST);
        fileTaskDelegator.registerFileParser(new MRK(Version.V_1_1_D), FileType.MRK);
        fileTaskDelegator.registerFileParser(new GAV(Version.V_1_1_D), FileType.GAV);
        fileTaskDelegator.registerFileParser(new SAM(Version.V_1_1_D), FileType.SAM);
        fileTaskDelegator.registerFileParser(new SON(Version.V_1_1_D), FileType.SON);
        fileTaskDelegator.registerFileParser(new LIN(Version.V_1_1_D), FileType.LIN);
        fileTaskDelegator.registerFileParser(new VLP(Version.V_1_1_D), FileType.VLP);
    }


    private static void registerVersion_1_2() {
        FileTaskDelegator fileTaskDelegator = FileTaskDelegator.getInstance();
        fileTaskDelegator.registerFileParser(new TIX(Version.V_1_2), FileType.TIX);
        fileTaskDelegator.registerFileParser(new TMS(Version.V_1_2), FileType.TMS);
        fileTaskDelegator.registerFileParser(new HPL(Version.V_1_2), FileType.HPL);
        fileTaskDelegator.registerFileParser(new DKO(Version.V_1_2), FileType.DKO);
        fileTaskDelegator.registerFileParser(new DST(Version.V_1_2), FileType.DST);
        fileTaskDelegator.registerFileParser(new MRK(Version.V_1_2), FileType.MRK);
        fileTaskDelegator.registerFileParser(new GAV(Version.V_1_2), FileType.GAV);
        fileTaskDelegator.registerFileParser(new SAM(Version.V_1_2), FileType.SAM);
        fileTaskDelegator.registerFileParser(new SON(Version.V_1_2), FileType.SON);
        fileTaskDelegator.registerFileParser(new LIN(Version.V_1_2), FileType.LIN);
        fileTaskDelegator.registerFileParser(new VLP(Version.V_1_2), FileType.VLP);
        fileTaskDelegator.registerFileParser(new TAB(Version.V_1_2), FileType.TAB);
        fileTaskDelegator.registerFileParser(new PER(Version.V_1_2), FileType.PER);
        fileTaskDelegator.registerFileParser(new RUT(Version.V_1_2), FileType.RUT);
    }


    private static void registerVersion_1_3_A() {
        FileTaskDelegator fileTaskDelegator = FileTaskDelegator.getInstance();
        fileTaskDelegator.registerFileParser(new HPL(Version.V_1_3_A), FileType.HPL);
        fileTaskDelegator.registerFileParser(new STP(Version.V_1_3_A), FileType.STP);
        fileTaskDelegator.registerFileParser(new TIX(Version.V_1_3_A), FileType.TIX);
        fileTaskDelegator.registerFileParser(new TMS(Version.V_1_3_A), FileType.TMS);
        fileTaskDelegator.registerFileParser(new DKO(Version.V_1_3_A), FileType.DKO);
        fileTaskDelegator.registerFileParser(new DST(Version.V_1_3_A), FileType.DST);
        fileTaskDelegator.registerFileParser(new MRK(Version.V_1_3_A), FileType.MRK);
        fileTaskDelegator.registerFileParser(new GAV(Version.V_1_3_A), FileType.GAV);
        fileTaskDelegator.registerFileParser(new SAM(Version.V_1_3_A), FileType.SAM);
        fileTaskDelegator.registerFileParser(new SON(Version.V_1_3_A), FileType.SON);
        fileTaskDelegator.registerFileParser(new LIN(Version.V_1_3_A), FileType.LIN);
        fileTaskDelegator.registerFileParser(new VLP(Version.V_1_3_A), FileType.VLP);
        fileTaskDelegator.registerFileParser(new TAB(Version.V_1_3_A), FileType.TAB);
        fileTaskDelegator.registerFileParser(new PER(Version.V_1_3_A), FileType.PER);
        fileTaskDelegator.registerFileParser(new RUT(Version.V_1_3_A), FileType.RUT);
    }
}
