package RegToppParser.models;

/**
 * Created on 24.11.14.
 * @author Espen
 */
public class FieldValuePair {


    private Field field;
    private Object value;

    public FieldValuePair(Field field, Object value) {
        this.field = field;
        this.value = value;
    }


    public Field getField() {
        return field;
    }


    public <T> T getValue() {
        return (T) value;
    }


    @Override
    public int hashCode() {
        return field.getFieldName().hashCode() + (13 * field.getBegin()) + (37 * field.getEnd()) + String.valueOf(value).hashCode();
    }


    @Override
    public boolean equals(Object o) {
        if(!(o instanceof FieldValuePair))
            return false;

        FieldValuePair other = (FieldValuePair) o;

        boolean fieldsEqual = other.field.equals(field);
        boolean objectEqual = other.value.equals(value);

        return fieldsEqual && objectEqual;

    }
}
