package RegToppParser.models;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created on 15.11.14.
 * @author Espen Jacobsson
 */
public class Post {
    
    
    private String line;
    private Map<Field, Object> fields = new HashMap<>();

	
    public Post(String line) {
		this.line = line;
	}
	
	
    public void addFields(Map<Field, Object> fieldValues) {

        for(Field key : fieldValues.keySet()) {
            if(!fields.containsKey(key)) {
                fields.put(key, fieldValues.get(key));
            }
        }
    }
    
    
    public <T> T getFieldValue(Field field) {
        if(fields.containsKey(field)) {
            return (T) fields.get(field);
        }
        return null;
    }
}
