package espenja;

import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.regex.Pattern;


public class Settings {

    public static final String INENCODING = "UTF-8";
    public static final String OUTENCODING = "UTF-8";
    
    public static final Path statCoordInputFile = Paths.get("data/statcoord2.pl");
    public static final Path statCoordOutputFile = Paths.get("data/statcoord2_new2.pl");
    public static final Path jsonOutputFile = Paths.get("data/oslo.json");

    public static final Pattern encodingPattern = Pattern.compile("/\\* -\\*- Mode:Prolog; coding:([^;]*); -\\*- \\*/", Pattern.CASE_INSENSITIVE); // Group(1) is utf-8 or iso-8859-1
    public static final Pattern statCoordPattern = Pattern.compile("^statcoord\\(([0-9]+),\\s*'(.*?)',\\s*(.*?),\\s*(.*?)\\)\\.$");
}
