package espenja;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;


public class StatCoordFileWriter {
    
    
    private List<String> prologLines = new ArrayList<>();
    private boolean headerWritten = false;
    
    private static StatCoordFileWriter statCoordFileWriter = null;
    
    private StatCoordFileWriter() { }
    
    public static StatCoordFileWriter getInstance() {
        if(statCoordFileWriter == null)
            statCoordFileWriter = new StatCoordFileWriter();
        
        return statCoordFileWriter;
    }
    
    
    public void addLine(String line) {
        
        if(!headerWritten) {
            System.err.println("CANNOT WRITE CONTENT BEFORE WRITING HEADER");
            System.exit(1);
        }
        
        prologLines.add(line.trim());
    }
    
    
    public void writeFile() {
        try(BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(Settings.statCoordOutputFile.toFile()), Charset.forName(Settings.OUTENCODING).toString()))) {
            for(String line : prologLines) {
                writer.write(line + "\n");
            }
        }
        catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void addHeader(String header) {
        
        prologLines.add(header);
        headerWritten = true;
    }
}
