package regtopToBusTUC;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Date;

public class VersionUpdate{

	public static void updateVersion( String comment, String path ) throws Exception{
		
		Date date = new Date();
		SimpleDateFormat format = new SimpleDateFormat("yyMMdd");
		String dateFormatted = format.format(date);		// yymmdd

		try { //Fix encoding
			comment = URLDecoder.decode( comment, ConvertRegTop.OUTPUT_ENCODING );
		} catch (UnsupportedEncodingException e) { e.printStackTrace(); }

		String data = "/* -*- Mode:Prolog; coding:utf-8; -*- */\n"
		+"%% Generated by regtopToBusTUC.VersionUpdate.java on "+new Timestamp(new Date().getTime())+"\n"
		+"%% FILE version.pl\n"
		+"%% SYSTEM TUC\n"
		+"%% CREATED TA-970913\n"
		+"/* REVISED : RS- */  version_date('AtB-I  Date "+dateFormatted+"')."
		+"\n\n"
		+"%% "+comment+"\n";

		//				version.pl
		File file = new File( path );

		//FileOS: false => new file , true => append file
		OutputStreamWriter fileWriter = new OutputStreamWriter( new FileOutputStream( file, false ), ConvertRegTop.OUTPUT_ENCODING  );
		BufferedWriter bufferWriter = new BufferedWriter( fileWriter );
		bufferWriter.append( data );
		bufferWriter.close();
	}//updateVersion

	public static void main( String[] args ){

		if(args.length != 2){
			String usage = "regtopToBusTUC.VersionUpdate [comment] [filepath] " +
					"Create new version.pl in [filepath]";
			System.err.println(usage);
			System.exit(1);
		}else{
			try{
				VersionUpdate.updateVersion(args[0], args[1]);
				System.out.println("version.pl created!");
			}catch(FileNotFoundException e){
				System.err.println("Failed to update -> File unavailable: "+e);
			}catch(Exception e){
				System.err.println("Failed to update: "+e);
			}
		}
	}

}//class VersionUpdate
